#include "keybase.h"
#include <iostream.h>
#include <strstream.h>
#include <unistd.h>
#include <stdlib.h>
#include <ncurses.h>
#include "global.h"

void newkey();
void accesskey(const int);
void lprkey();
void scpkey();
void showlog();
void moin_moin();
void sortkey();

#define ACTION_RENAME 1
#define ACTION_DELETE 2
#define ACTION_LIST   3


keybase key (KEYFILE);

int main() {
  char command [256];
  moin_moin();
  do {
    cout << "========================================"\
         << "========================================" << endl;
    cout << " (1) Schluessel eintragen\t\t"\
         << " (6) Schluesselliste sortieren " << endl;
    cout << " (2) Schluessel loeschen\t\t"\
         << " (7) Schluesselliste uebertragen " << endl;
    cout << " (3) Namen aendern\t\t\t"\
         << " (8) Logfile anzeigen " << endl;
    cout << " (4) Schluesselliste ausgeben\t\t"\
         << " (9) Passwort aendern " << endl;
    cout << " (5) Schluesselliste ausdrucken\t\t"\
         << " (0) Ende " << endl;
    cout << " > " << flush;
    cin.getline(command,256);
    cout << CLS << endl;
    switch (command[0]) {
      case '1': newkey(); break;
      case '2': accesskey(ACTION_DELETE); break;
      case '3': accesskey(ACTION_RENAME); break;
      case '4': accesskey(ACTION_LIST); break;
      case '5': lprkey(); break;
      case '6': sortkey(); break;
      case '7': scpkey(); break;
      case '8': showlog(); break;
      case '9': system("passwd"); break;
    };
  } while (command[0] != '0');
  exit(0);
}


void newkey() {
  ifstream in;
  string name;
  string lastkey;
  int counter = 0;
  int checkupdate = 0;

  in.open (LASTKEYFILE);
  in >> counter;
  checkupdate = counter;
  in.close();
  
  cout << "Transponder vor den Empfnger halten." << endl;
  while (checkupdate == counter) {
    in.open (LASTKEYFILE);
    in >> checkupdate;
    in >> lastkey;
    in.close();
    cout << "." << flush;
    usleep(5000);
  }
  cout << endl;
  if ( key.check(lastkey,&name) ) {
    cout << "Dieser Schluessel existiert schon und gehoert" << name << endl;
  } else {
    cout << "Neuer Schluessel: " << lastkey << endl; 
    cout << "Bitte den Namen des Benutzers eingeben: " << flush;
    getline(cin,name);
    key.add(lastkey, name);
    cout << "Schluessel eingetragen." << endl;
  }
}

void lprkey() {
  char temp[256];
  sprintf(temp,"lpr %s", KEYFILE);
  system(temp);
}

void sortkey() {
  char temp[256];
  sprintf(temp,"sort -k 2 %s > /tmp/sort.key", KEYFILE);
  system(temp);
  sprintf(temp,"rm %s", KEYFILE);
  system(temp);
  sprintf(temp,"mv /tmp/sort.key %s", KEYFILE);
  system(temp);
  cout << "Sortierung abgeschlossen" << endl;
}

void scpkey() {
  char command[256];
  char username[256];
  char t[1024];
 
  cout << "Dein Username auf " << REMOTE << ": " << flush;
  cin.getline(t,256);
  istrstream tempstr1(t);
  tempstr1 >> username;
  
  sprintf(command, "scp %s %s@%s:", KEYFILE, username, REMOTE); 
  system(command);
}

void moin_moin() {
  cout << CLS << endl;
  cout << "Schluesselverwaltung" << endl;
  cout << "by Daniel Schramm" << endl << endl;
}


void showlog() {
  char temp[256];
  sprintf(temp,"less %s", LOGFILE);
  system(temp);
}


void accesskey(const int action) {
  deque<string> userlist;
  string name="";
  int i;

// Zeilenzahl ueber curses erfragen.
  initscr();
  int screensize=LINES-2;
  endwin();


  if ( action==ACTION_DELETE || action==ACTION_RENAME ) {
    cout << endl;
    cout << "Vorauswahl" << endl;
    cout << "Schluesselbesitzer eingeben (oder Return fuer alle): " << flush;
    getline(cin,name);
  }
  
  if ( name.size()==0 )
    key.read(userlist);
  else
    key.read(userlist,name);

  int ul_size=userlist.size();
  i=0;
  int offset=0;
  int end=0;
  char t[256];


  while (( i < ul_size) && ( ! end )) {
    cout << CLS << endl;
    
    if ((i + screensize) < ul_size) 
      offset=i + screensize;
    else
      offset=ul_size;
    
    for (; i < offset ; i++)
      cout << i+1 << ": " << userlist[i] << endl;
    cout << endl;

    switch (action) {
      case ACTION_DELETE :
        cout << "Welcher Name soll ausgetragen werden? (<enter> fuer weiter): " << flush;
        break;
      case ACTION_RENAME :
        cout << "Welcher Name soll geaendert werden? (<enter> fuer weiter): " << flush;
        break;
      case ACTION_LIST :
        cout << "Weiter mit <enter>" << flush;
        break;
    }

    cin.getline(t,256);
    if ( strlen(t) ) {
      end=1;
      istrstream tempstr1(t);
      tempstr1 >> i;

      userlist[i-1].copy(t,256);
      istrstream tempstr2(t);
      tempstr2 >> t;
      key.del(t);
    
      if ( action==ACTION_RENAME ) {
        cout << "Neuen Namen eingeben: " << flush;
        getline(cin,name);
        key.add((string)t,name);
      }
    }
  }
}
